<?php

	include("../M0/session_start.php") ;

	//-------------------------------------------------------------------------------------
	if ( $_SESSION['level'] != 127 ) {
		header('Location: ' . $root_dir . '/M1/index_2.php');
		exit();
	}

	include("../M0/communs_en_tete_HTML.html") ;
	
	$back_link = "../M6/dexin.php";
	include('../M0/communs_en_tete_home_back.html');

	$return_path = "/M3/gestion_sites.php" ;
	include('../M0/display_user_only.php'); 

?>

<table align="center" width="<?php echo $tables_width ; ?>"  border="2" cellspacing="2" cellpadding="2" bordercolor="#ffffff" bgcolor="#000033">	
	<tr>
	
		<td width="10px" style="border-right: 0px;" >
			&nbsp;
		</td>
		
		<td align="left" width="98%" style="border-left: 0px;" >
		

			<?php

				//-----------------------------------------------------------------------------------------------------
				// création d'un mot de passe de 24 caractères
				//-----------------------------------------------------------------------------------------------------
				$taille = 24 ;

				// Liste des caractères possibles
				$cars="bcdefghijklnprstuvxyBCDEFGHIJKLNPRSTUVXY123456789";
				$mdp='';
				$long=strlen($cars);

				srand((double)microtime()*1000000); //Initialise le générateur de nombres aléatoires

				for($i=0;$i<$taille;$i++) $mdp=$mdp.substr($cars,rand(0,$long-1),1);

				// résultat : $mdp

				//-----------------------------------------------------------------------------------------------------
				// 
				//-----------------------------------------------------------------------------------------------------
				$mot_de_passe		= $mdp ;
				 
				$mot_de_passe_hash	= password_hash($mot_de_passe, PASSWORD_DEFAULT);

				echo("</br>");

				echo ("<u>mot de passe (#24) et son « hash »</u></br></br>");
				
				echo ("password : " . $mot_de_passe);	// 
				echo("</br>");
				echo ("hash(password) : </br>");
				echo("<font size='2'>");
				echo ($mot_de_passe_hash);	// 
				echo("</font >");
				echo("</br></br>");

				if ( password_verify($mot_de_passe, $mot_de_passe_hash ) ) {
					echo("OK...");
				}
				else {
					echo("not OK !!!");
				}
				echo("</br></br>");



				echo ("<u>2FA authentication : secret / TOTP </u></br></br>");

				include("../M0/2FAS_Authenticator.php");

				// Generate a secure secret
				$secret = Authenticator::createSecret(16);
				echo("2FAS secret : $secret");echo("</br>");

				// Generate a TOTP code
				$code = Authenticator::generateCode($secret);
				echo("code de test : $code");echo("</br></br>");
				
				// Verify the code
				$isValid = Authenticator::verifyCode($secret, $code);
				echo $isValid ? "OK..." : "not OK !!!";echo("</br></br>");

				// Generate a QR code URL for Google Authenticator
				$qrCodeUrl = Authenticator::generateQrCodeUrl("", $secret, "AQCM05");
				//echo $qrCodeUrl;echo("</br></br>");

				//echo("<a href=$qrCodeUrl>lien</a>");

				echo("<img src=$qrCodeUrl height='140' />");

				echo ("</br></br>");

				/*
				*/
				
			?>
						
		</td>
		
	</tr>
</table>

</body>
</html>


